
/* packet-xxx-subiss.c
 * 
 *
 * $Id: README.developer,v 1.78 2003/07/30 23:18:55 guy Exp $
 *
 * Ethereal - Network traffic analyzer
 * By Gerald Combs <gerald@ethereal.com>
 * Copyright 1998 Gerald Combs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif


/**************Plugin Rquirements**************************/

#include "plugins/plugin_api.h"
#include "moduleinfo.h"
#include <gmodule.h>
#include "plugins/plugin_api_defs.h"

#ifndef ETHEREAL_STATIC
G_MODULE_EXPORT const gchar version[] = VERSION;
#endif

/**********************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <glib.h>

#ifdef NEED_SNPRINTF_H
# include "snprintf.h"
#endif

#include <epan/packet.h>
#include "packet-xxx-subiss.h"


/* Initialize the protocol and registered fields */

static int proto_xxx_subiss = -1;
static int hf_xxx_subiss_subiss = -1;


/* Initialize the subtree pointers */
/*static gint ett_PROTOABBREV = -1;*/
static gint ett_xxx_subiss = -1;


/* A static handle for the 802.11 dissector */
static dissector_handle_t wlan_handle;

/* Code to actually dissect the packets */
static void
dissect_xxx_subiss(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree)
{

/* Set up structures needed to add the protocol subtree and manage it */
	proto_tree *ti;
	/*proto_tree *PROTOABBREV_tree;*/
	proto_tree *xxx_subiss_tree;
	tvbuff_t *next_tvb;
	guint32 cccid;
	int tvLength = 0;
	
	printf("\ncallin dissect xxxSubISS");

/* Make entries in Protocol column and Info column on summary display */
	if (check_col(pinfo->cinfo, COL_PROTOCOL)) 
	  col_set_str(pinfo->cinfo, COL_PROTOCOL, "xxx_subiss");
	if (check_col (pinfo->cinfo, COL_INFO))
	  col_clear(pinfo->cinfo, COL_INFO);

/* Get the CCCID */
	cccid = tvb_get_ntohl(tvb,0);
    
/* This field shows up as the "Info" column in the display; you should make
   it, if possible, summarize what's in the packet, so that a user looking
   at the list of packets can tell what type of packet it is. See section 1.5
   for more information.

   If you are setting it to a constant string, use "col_set_str()", as
   it's more efficient than the other "col_set_XXX()" calls.

   If you're setting it to a string you've constructed, or will be
   appending to the column later, use "col_add_str()".

   "col_add_fstr()" can be used instead of "col_add_str()"; it takes
   "printf()"-like arguments.  Don't use "col_add_fstr()" with a format
   string of "%s" - just use "col_add_str()" or "col_set_str()", as it's
   more efficient than "col_add_fstr()".

   If you will be fetching any data from the packet before filling in
   the Info column, clear that column first, in case the calls to fetch
   data from the packet throw an exception because they're fetching data
   past the end of the packet, so that the Info column doesn't have data
   left over from the previous dissector; do

	if (check_col(pinfo->cinfo, COL_INFO)) 
		col_clear(pinfo->cinfo, COL_INFO);

   */

	if (check_col(pinfo->cinfo, COL_INFO)) 
	  {
	  /*col_set_fstr(pinfo->cinfo, COL_INFO, "XXX Request");*/
	    col_add_fstr(pinfo->cinfo, COL_INFO, "CCCID: %u",cccid);
	  }

/* In the interest of speed, if "tree" is NULL, avoid building a
   protocol tree and adding stuff to it if possible.  Note,
   however, that you must call subdissectors regardless of whether
   "tree" is NULL or not. */
	if (tree) 
	{

	  printf("\nInside protocol tree");

/* NOTE: The offset and length values in the call to
   "proto_tree_add_item()" define what data bytes to highlight in the hex
   display window when the line in the protocol tree display
   corresponding to that item is selected.

   Supplying a length of -1 is the way to highlight all data from the
   offset to the end of the packet. */

	  /*create display subtree for the protocol */
	  /* ti = proto_tree_add_item(tree, proto_xxx_subiss, tvb, 0, 10, FALSE);*/

	  tvLength = tvb_length(tvb);
	  printf("\nTVB length = %d",tvLength);

	  ti = proto_tree_add_protocol_format(tree, proto_xxx_subiss, tvb, 0, 10, "SUB_ISS");

	  xxx_subiss_tree = proto_item_add_subtree(ti, ett_xxx_subiss);
		/*proto_tree_add_uint(xxx_subiss_tree,hf_pcli_cccid,tvb,
		  0,4,cccid);*/

		/* add an item to the subtree, see section 1.6 for more information */
		//proto_tree_add_item(xxx_subiss_tree, hf_xxx_subiss_subiss, tvb, 0, -1, FALSE)

/* Continue adding tree items to process the packet here */

	}
	
	
	next_tvb = tvb_new_subset(tvb,20,10,-1);
	call_dissector(wlan_handle,next_tvb,pinfo,tree);

/* If this protocol has a sub-dissector call it here, see section 1.8 */
}


/* Register the protocol with Ethereal */

/* this format is require because a script is used to build the C function
   that calls all the protocol registration.
*/

void
proto_register_xxx_subiss(void)
{                 

/* Setup list of header fields  See Section 1.6.1 for details*/
	static hf_register_info hf[] = {
		{ &hf_xxx_subiss_subiss,
			{ "sub_ISS_JUNK",           "xxx_subiss.subiss",
			FT_NONE, BASE_HEX, NULL, 0,"Displays subISS frame", HFILL }
		},
	};

/* Setup protocol subtree array */
	static gint *ett[] = {
		&ett_xxx_subiss,
	};

/* Register the protocol name and description */
  
        printf("\nCalling to register the Athena's protocol\n");
	proto_xxx_subiss = proto_register_protocol("xxx's SubISS", "SUB_ISS", "xxx_subiss");
	 

/* Required function calls to register the header fields and subtrees used */
	proto_register_field_array(proto_xxx_subiss, hf, array_length(hf));
	proto_register_subtree_array(ett, array_length(ett));

	register_dissector("xxx_subiss", dissect_xxx_subiss, proto_xxx_subiss);
}


/* If this dissector uses sub-dissector registration add a registration routine.
   This format is required because a script is used to find these routines and
   create the code that calls these routines.
*/
void
proto_reg_handoff_xxx_subiss(void)
{
  
        static int xxx_subiss_initialized = FALSE;
	dissector_handle_t xxx_subiss_handle;

	wlan_handle = find_dissector("wlan");
	printf("\nCalling proto_reg_handoff_xxx()");

	if(!xxx_subiss_initialized)
	  {
	    xxx_subiss_handle = create_dissector_handle(dissect_xxx_subiss, proto_xxx_subiss);
	    xxx_subiss_initialized = TRUE;
	  }
	 /* dissector_add("PARENT_SUBFIELD", ID_VALUE, xxx_subiss_handle);*/
}




#ifndef ETHEREAL_STATIC
G_MODULE_EXPORT void plugin_reg_handoff(void)
{
  proto_reg_handoff_xxx_subiss();
}

G_MODULE_EXPORT void plugin_init(plugin_address_table_t *pat
#ifndef PLUGINS_NEED_ADDRESS_TABLE
_U_
#endif
)
{
  /* initialise the table of pointers needed in Win32 DLLs */
  plugin_address_table_init(pat);
  /* register the new protocol, protocol fields, and subtrees */

  if (proto_xxx_subiss == -1) { /* execute protocol initialization only once */
    proto_register_xxx_subiss();
  }
}

#endif
